<?php

// src/EventListener/MenuBuilderListener.php

namespace App\EventListener;

use App\Entity\GlobalParameter;
use App\Entity\SolidoumeParameter;
use Doctrine\ORM\EntityManagerInterface;
use Knp\Menu\Util\MenuManipulator;
use Sonata\AdminBundle\Event\ConfigureMenuEvent;

final class MenuBuilderListener
{
    private $em;

    public function __construct(EntityManagerInterface $em)
    {
        $this->em = $em;
    }

    public function addMenuItems(ConfigureMenuEvent $event): void
    {
        $menu = $event->getMenu();

        $useSolidoume = $this->em->getRepository(GlobalParameter::class)->val(GlobalParameter::USE_SOLIDOUME);
        $soliParam = $this->em->getRepository(SolidoumeParameter::class)->findTheOne();
        $name = 'Sécurité sociale alimentaire';
        if (!empty($soliParam)) {
            $name = $soliParam->getName();
        }

        if ('true' == $useSolidoume) {
            $child = $menu->addChild('reports', [
                'label' => $name,
                'route' => 'solidoume_list',
            ])->setExtras([
                'icon' => '<i class="fa fa-handshake-o"></i>', // html is also supported
            ]);
            $manipulator = new MenuManipulator();
            $manipulator->moveToPosition($child, 7);
        }
    }
}
